<html>
<head>
    <link rel="stylesheet" href="https://bootswatch.com/4/sketchy/bootstrap.min.css" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.3.1.min.js" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js" crossorigin="anonymous"></script>
</head>
<body>
<div class="container" style="margin-top: 30px;">
    <nav class="navbar navbar-expand-md navbar-dark bg-dark mb-4">
        <a class="navbar-brand" href="#">Lumen Example</a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarCollapse" aria-controls="navbarCollapse" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarCollapse">
            <ul class="navbar-nav mr-auto">
                <li class="nav-item active">
                    <a class="nav-link" href="#">Home <span class="sr-only">(current)</span></a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="https://www.keks.cloud">keks.cloud</a>
                </li>
            </ul>
        </div>
    </nav>
    <div class="row">
        <div class="col-md-12">
            <h1>Lumen Example</h1>
            This is a lumen sample app with docker and kubernetes config to run in the keks.cloud. It can be used to create small webguis or even better api endpoints. It contains the following content:<br><br>
            <ul>
                <li>Lumen Project</li>
                <li>Config for Lumen queues</li>
                <li>Docker container</li>
                <li>Docker-compose config</li>
                <li>Kubernetes config</li>
            </ul>
            <br>
            I use this script that i can create a web or api prototyp without caring about the basic config each time.

            <h3>What about crons?</h3>
            <p>Use <a href="https://kubernetes.io/docs/concepts/workloads/controllers/cron-jobs/">Kubernetes Crons</a>.</p>

            <h3>What about queues?</h3>
            <p>The Project setup is based on the mysql queue driver. The migrations will be execute while the start of the docker container.</p>

            <h3>Where is the docker config?</h3>
            <p>The docker config is in the /resources/docker folder, it contains the Dockerfiles and all needet files to run the project in docker with docker-compose.</p>

            <h3>Build app</h3>
            <p>To run the app in kubernetes you need to build the docker container. Therefor is a script in the resources/build folder. Before you first start the script change the name of the tag to your projectname, replace the sampleapp. Go in this folder and execute the script to build the container and push them to docker.keks.cloud.</p>

            <h3>Run the App in Kubernetes?</h3>
            <p>The App contains information to run it on kubernetes. All needet config files are in the resources/kubernetes folder. If you want to run the app in kubernetes you want to change the url and the enivoment files.</p>
            <p>You need to change the Namespace name, in this app it is always "sampleapp" you can search it in the kubernetes folder and need to replace it in each file.</p>

            <h4>MYSQL</h4>
            <p>If you want to run a MYSQL-Server in Kubernetes (just do it if it a prototyp) you need to change and deploy the config-mysql.yml, deployment-mysql.yml and service-mysql.yml</p>
            <p>To save the information you need a persistent volume called <code>mysql</code>, or you disabled it in the deplyoment-mysql.yml</p>
            <p>If you run the MYSQL-Server in the keks.cloud you can add the config-mysql-backup.yml and cron-mysql-backup.yml to enabled the backup to s3</p>

            <h2>Download / Git</h2>
            <p>You can get the Project from <a href="https://git.keks.cloud/kekskurse/lumenInit">its git.keks.cloud project</a> or download the last version as <a href="https://git.keks.cloud/kekskurse/lumenInit/archive/master.zip">ZIP</a> or <a href="https://git.keks.cloud/kekskurse/lumenInit/archive/master.tar.gz">TAR.GZ</a>.</p>

        </div>
    </div>
</div>
</body>
</html>
